/*
Solve matrix & show steps by Lee Jordan Oct. 16, 1993
compile small
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define ROWS 100
#define COLS 100



float mat[ROWS][COLS];



clear_mat(rows, cols)
int rows;
int cols;
{
int i,j;

for (i = 0; i < rows; i++)
  {
  for (j = 0; j < cols; j++)
    {
    mat[i][j] = 0.0;
    }
  }
}



show_mat(rows, cols)
int rows;
int cols;
{
int i,j;

for (i = 0; i < rows; i++)
  {
  printf("%3d.", i+1);
  for (j = 0; j < cols; j++)
    {
    if (mat[i][j] == -0.0)
      {
      mat[i][j] = 0.0;
      }
    printf(" %8.3f", mat[i][j]);
    }
  printf("\n");
  }
  printf("\n\n\n");
}



swap_rows(r1, r2, rows, cols) 
int r1;
int r2;
int rows;
int cols;
{
float arow[COLS];
int i;

if (r1 < rows && r2 < rows)
  {
  for (i= 0; i < cols; i++)
    arow[i] = mat[r1][i];

  for (i= 0; i < cols; i++)
    mat[r1][i] = mat[r2][i];

  for (i= 0; i < cols; i++)
    mat[r2][i] = arow[i];
  }
}



int non_zero(start, rows)
int start;
int rows;
{
int i;

  for (i= start; i < rows; i++)
    if (mat[i][start] != 0.0)
       return(i);

return(-1);
}



int sort_mat(rows, cols)
int rows;
int cols;
{
int i;
int toswap;
int swaped;

  swaped = 0;
  for (i= 0; i < rows; i++)
    {
    if (mat[i][i] == 0.0)  /* row col */
      {
      if ((toswap = non_zero(i, rows)) != -1)
        {
        swaped = 1;
        printf("Swap Row %d & Row %d\n", toswap+1, i+1);
        swap_rows(toswap, i, rows, cols);
        }
      else
        {
        /*
        printf("\nNo non zero rows below.\n");
        */
        }
      }
    }
  return(swaped);
}



adjust(i, pivot, to_mul, cols)
int i;
int pivot;
float to_mul; /* multiply pivot row & subtract from i row */
int cols;
{
int j;

  printf("Row %d = Row %d - \(Row %d x %8.3f\)\n", i+1, i+1, 
          pivot+1, to_mul);
  for (j = 0; j < cols; j++)
    {
    mat[i][j] = mat[i][j] - (mat[pivot][j] * to_mul);
    }
}



adjust_pivot(pivot, cols)
int pivot;
int cols;
{
int j;
float to_div;

  to_div = mat[pivot][pivot];

  printf("Row %d = Row %d / %8.3f\n", pivot+1, pivot+1, to_div);
  for (j = 0; j < cols; j++)
    {
    mat[pivot][j] = mat[pivot][j] / to_div;
    }
}



make_pivot(pivot, rows, cols)
int pivot;
int rows;
int cols;
{
float to_mul;
int i;

  if(mat[pivot][pivot] != 0.0)
    {
    if (mat[pivot][pivot] != 1.0)
      {
      adjust_pivot(pivot, cols);
      printf("\nMatrix\n");
      show_mat(rows, cols);
      }

    for (i= 0; i < rows ; i++)
      {
      if (i != pivot)
        {
        to_mul = mat[i][pivot] / mat[pivot][pivot];
        if (to_mul != 0.0)
          adjust(i, pivot, to_mul, cols);
        }
      }
    }
}



gomat(rows, cols)
int rows;
int cols;
{
int i;

  for (i = 0; i < rows; i++)
    {
    if (sort_mat(rows, cols))
      {
      printf("\nResorted matrix.\n");
      show_mat(rows, cols);
      }

    printf("Perform operations:\n");
    make_pivot(min(min(i,rows), cols), rows, cols);
    printf("\nResults of operations.\n");
    show_mat(rows, cols);
    }
}



int is_dec(ch)
unsigned char ch;
{
  return((ch >= '0' && ch <= '9') || ch == '.' || ch == '-' );
}



int count_cols(istr)
char *istr;
{
int cnt;
int ptr;
int hit;
int len;

  cnt = 0;
  ptr = 0;
  len = strlen(istr);

  while(istr[ptr] != '\0')
    {
    while(!is_dec(istr[ptr]) && istr[ptr] != '\0')
      {
      ptr++;
      }

    hit = 0;
    while(is_dec(istr[ptr]) && istr[ptr] != '\0')
      {
      hit = 1;
      ptr++;
      }
    if (hit)
      cnt++;
    }
  return(cnt);
}



get_line(istream, at_most, istr)
FILE *istream;
int at_most;
char *istr;
{
unsigned char ch;
int ptr;

  ptr = 0;
  while(!feof(istream))
    {
    ch = fgetc(istream);
    if (ch == '\n' || feof(istream) || ptr >= at_most)
       {
       break;
       }
    istr[ptr++] = ch;
    }
  istr[ptr] = '\0';
}



read_rows(rows, cols)
int *rows;
int *cols;
{
char istr[256];
char ostr[256];
int icnt;
int ocnt;
int len;
int token_cnt;
FILE *istream;
int row_cnt;
int col_cnt;
int hit;

  row_cnt = 0;
  col_cnt = 0;
  token_cnt = 0;

  if ((istream = fopen( "solve.in","rt")) == NULL)
    {
    printf("Please create SOLVE.IN ASCII text file.\n");
    exit(1);
    }

  while(!feof(istream))
    {
    icnt = 0;
    get_line(istream, 256, istr);
    hit = 0;
    if ((len = strlen(istr)) > 0 && istr[0] != ' ' && istr[0] != '\t')
      {
      /* printf("Line: %s\n", istr); */

      if (token_cnt == 0)
        col_cnt = count_cols(istr);

      while(icnt < len)
        {
        while (!is_dec(istr[icnt]) && icnt < len)
          {
          icnt++;
          }

        ocnt = 0;
        while (is_dec(istr[icnt]) && icnt < len)
          {
          ostr[ocnt++] = istr[icnt++];
          }
        ostr[ocnt] = '\0';

        if ((strlen(ostr)) > 0)
          {
          hit = 1;
   /*       printf("Loc:%d\,%d = %f\n", row_cnt, token_cnt % 
                             col_cnt, atof(ostr)); */
          mat[row_cnt][token_cnt % col_cnt] = atof(ostr);
          token_cnt++;
          }
        }
      }
    if (hit)
      row_cnt++;
    }
  fclose (istream);
  *cols = col_cnt;
  *rows = row_cnt;
}



main()
{
int rows, cols;
  printf("\nSolve System of equations v1.1  by Lee Jordan  Oct. 19, 1993\n");

  clear_mat(ROWS, COLS);
  printf("\nMatrix\n");
  read_rows(&rows, &cols);
  show_mat(rows, cols);
  gomat(rows, cols);
}
